package DPEMS;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class FarmerInfo extends DPEMS {
	void farmerReportEntry() {
		try {
			System.out.println("-----Farmer Report Entry-----");
			String qq = "select distinct (Product_name) from ProductInfo";
			PreparedStatement ps2 = con.prepareStatement(qq);
			ResultSet resultSet1 = ps2.executeQuery();
			System.out.println("Product Names: ");
			while (resultSet1.next()) {
				String Product_name = resultSet1.getString("Product_name");
				System.out.println(Product_name);
			}
			System.out.println("Enter product name ");
			String pn = "";
			while (pn.length() <= 0) {
				pn = sc.nextLine();
				if (pn.length() <= 0) {
					System.out.println("This field is required");
				}
			}
			System.out.println("Enter farmer name ");
			String fn = "";
			while (fn.length() <= 0) {
				fn = sc.nextLine();
				if (fn.length() <= 0) {
					System.out.println("This field is required");
				}
			}
			System.out.println("Enter quantity");
			float fq = -1;
			while (fq < 0) {
				fq = sc.nextFloat();
				if (fq < 0) {
					System.out.println("Quantity cannot be negative. Enter a non-negative quantity:");
				}
			}
			System.out.println("Enter 1 liters price");
			double fp = -1.0;
			while (fp < 0.0) {
				fp = sc.nextDouble();
				if (fp < 0.0) {
					System.out.println("Price cannot be negative. Enter a non-negative price:");
				}
			}
			String q = "insert into farmerinfo(farmer_name,quantity,price)values(?,?,?)";
			PreparedStatement pst = con.prepareStatement(q);
			pst.setString(1, fn);
			pst.setFloat(2, fq);
			pst.setDouble(3, fp);
			String q1 = "select quantity from productInfo where product_name=?";
			PreparedStatement pst1 = con.prepareStatement(q1);
			pst1.setString(1, pn);
			ResultSet r1 = pst1.executeQuery();
			float quantity = 0;
			while (r1.next()) {
				quantity = (r1.getInt(1) + fq);
			}

			String q2 = "update productInfo set quantity=? where product_name=?";
			PreparedStatement ps = con.prepareStatement(q2);
			ps.setFloat(1, quantity);
			ps.setString(2, pn);
			int r = ps.executeUpdate();
			System.out.println((r == 1) ? "Farmer Info Added Succesfully!!!" + (pst.executeUpdate()) : "Not added!");
		} catch (SQLException e) {
			System.out.println("Something went wrong in SQL Try Again!!!");
		} catch (Exception e) {
			System.out.println("Something went wrong Try Again!!!");
		}
		sc.nextLine();
	}

	void farmerinfoupdate() {
		try {
			System.out.println("-----Farmer Info Update-----");
			String q1 = "select distinct (farmer_name) from FarmerInfo";
			PreparedStatement pst1 = con.prepareStatement(q1);
			ResultSet resultSet1 = pst1.executeQuery();
			System.out.println("Farmer Names: ");
			while (resultSet1.next()) {
				String farmerName = resultSet1.getString("farmer_name");
				System.out.println(farmerName);
			}
			System.out.println("Enter farmer name ");
			String fn = "";
			while (fn.length() <= 0) {
				fn = sc.nextLine();
				if (fn.length() <= 0) {
					System.out.println("This field is required");
				}
			}
			System.out.println("Enter new price");
			double fp = -1.0;
			while (fp < 0.0) {
				fp = sc.nextDouble();
				if (fp < 0.0) {
					System.out.println("Price cannot be negative. Enter a non-negative price:");
				}
			}
			String q = "update farmerinfo set price=? where farmer_name=?";
			PreparedStatement pst = con.prepareStatement(q);
			pst.setDouble(1, fp);
			pst.setString(2, fn);
			int r = pst.executeUpdate();
			System.out.println((r > 0) ? "Updated Succesfully!!!" : "Not Updated!!");
		} catch (SQLException e) {
			System.out.println("Something went wrong in SQL Try Again!!!");
		} catch (Exception e) {
			System.out.println("Something went wrong Try Again!!!");
		}
		sc.nextLine();
	}

	void farmerInfoDeleted() {
		try {
			System.out.println("-----farmer Info Deleted-----");
			String q1 = "select distinct (farmer_name) from FarmerInfo";
			PreparedStatement pst1 = con.prepareStatement(q1);
			ResultSet resultSet1 = pst1.executeQuery();
			System.out.println("Farmer Names: ");
			while (resultSet1.next()) {
				String farmerName = resultSet1.getString("farmer_name");
				System.out.println(farmerName);
			}
			System.out.println("Enter farmer_name ");
			String fn = "";
			while (fn.length() <= 0) {
				fn = sc.nextLine();
				if (fn.length() <= 0) {
					System.out.println("This field is required");
				}
			}
			String q = "delete from farmerinfo where farmer_name=?";
			PreparedStatement pst = con.prepareStatement(q);
			pst.setString(1, fn);
			System.out.println("Press Y to confirm deletion...");
			char ch = sc.next().charAt(0);
			if (ch == 'y' || ch == 'Y') {
				int r = pst.executeUpdate();
				System.out.println((r > 0) ? "Deleted!!!" : "Not Deleted");
			} else {
				System.out.println("Process Terminated!!");
			}
		} catch (SQLException e) {
			System.out.println("Something went wrong in SQL Try Again!!!");
		} catch (Exception e) {
			System.out.println("Something went wrong Try Again!!!");
		}
		sc.nextLine();
	}

	void farmerInfoReport() {
		try {
			System.out.println("-----farmer Info Report-----");
			String q = "select * from farmerInfo";
			PreparedStatement pst1 = con.prepareStatement(q);
			ResultSet resultSet = pst1.executeQuery();
			while (resultSet.next()) {
				int farmerId = resultSet.getInt("farmer_id");
				String farmerName = resultSet.getString("farmer_name");
				float quantity = resultSet.getFloat("quantity");
				double price = resultSet.getDouble("price");
				String date = resultSet.getString("date");
				System.out.println("farmer ID: " + farmerId);
				System.out.println("farmer Name: " + farmerName);
				System.out.println("Quantity: " + quantity);
				System.out.println("Price: $" + price);
				System.out.println("Date: " + date);
				System.out.println("-------------------------------------------");
			}

		} catch (SQLException e) {
			System.out.println("Something went wrong in SQL Try Again!!!");
		}

	}
}
